#Document type for one from SmartDocumentStorage.
type Document
{
    id: Long!
    created: String
    assignedTemplates: [Template!]
    customFieldValues: [CustomField!]
    documentLinks: [DocumentLink!]
}

extend type Query
{
    #Finds Document by it's id. Will return error if no Document with such id is found.
    documentById( id: Long! ): Document

    #Returns a page of Documents.
    documents( page: Int, size: Int, sort: String ): [Document]
}

extend type Mutation
{
    #Creates or updates document.
    #If id is not provided - this method will create new document, otherwise - it will update one with provided id.
    #If one of the DocumentLinkInput directions will be null - they will be replaced with updated or created document id.
    document( id: Long, created: String, assignedTemplates: [Long!], customFieldValues: Map, links: [DocumentLinkInput] ): Document!
}